#include <gl/glut.h> //glut library, it imports gl.h, glu.h
#include <iostream> //standard IO

using namespace std;

void display(void)
{

	//...some OpenGL initialization functions

	/* contents of back buffer are set to become that of
	   front buffer (double buffering)*/
	glutSwapBuffers ();
}

void controlMenu(int x)
{
	/* basic switch control structure, prints the text
	   corresponding to the selected action in the command
	   prompt window */
	switch(x)
	{
		case 1: cout << "First item selected" << endl;
			break;
		case 2: cout << "Second item selected" << endl;
			break;
		case 3: exit(0); //terminate the application
	}
	/* set the current window for redisplay */
	glutPostRedisplay();
}

void menu()
{
	/* create a new pop-up menu */
	glutCreateMenu(controlMenu);

	/* add menu entries to the bottom of the current menu */
	glutAddMenuEntry("First Item",1);
	glutAddMenuEntry("Second Item",2);
	glutAddMenuEntry("Quit",3);

	/* attach the right mouse button for menu selection */
	glutAttachMenu(GLUT_RIGHT_BUTTON);
}

int main(int argc, char** argv)
{
	/* initialize the GLUT library. */
	glutInit(&argc, argv);

	/* set the initial display mode: double buffering and a
	   depth buffer. */
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);

	/* set default window size */
	glutInitWindowSize(300, 200);

	/* create a top-level window with a caption */
	glutCreateWindow("...event-driven mouse input...");

	/* display our contents in the window */
	glutDisplayFunc(display);

	/* call our menu function */
	menu();

	/* enter the GLUT event processing loop - will handle
	   any callback */
	glutMainLoop();

	return 0;
}